#!/usr/local/bin/php
<?php

main();
exit(0);

function emit_html_table()
{
  $dbcon=pg_connect(get_db_connect_string());
  if (!$dbcon) barf("DB Connect Error");

	print "<table border=2 cellpadding=5>\n";

	$time_interval_array = array("24 hours", "48 hours", "72 hours", "7 days"//, "1 month", "3 months", "6 months", "1 year"
	                            );
	print "<tr bgcolor=\"#99CCFF\"><th rowspan=2>Sensor</th><th rowspan=2>Now</th>";
	foreach ($time_interval_array as $t)
	{
		print "<th colspan=2>$t</th>\n";
	};
	print "</tr>\n" ;
	print "<tr bgcolor=\"#99CCFF\">";
	foreach ($time_interval_array as $t)
	{
		print "<th>Min</th><th>Max</th>\n";
	};
	print "</tr>\n" ;

	query_min_max("<b>temp-outdoor</b>",          "temperature",  "outdoor", "0","C","%.1f", 1.0, 8);
	query_min_max("<b>temp-soil-10cm</b>",        "temperature",  "outdoor", "0","C","%.1f", 1.0, "a");
	//query_min_max("<b>temp-garage</b>",           "temperature",  "outdoor", "0","C","%.1f", 1.0, 9);
	//query_min_max("<b>temp-indoor</b>",           "temperature",  "indoor",  "0","C","%.1f");
	query_min_max("<b>rel. humidity-out</b>",     "humidity",     "outdoor", "0","%","%d", 1.0, 8);
	//query_min_max("<b>rel. humidity-garage</b>",  "humidity",     "outdoor", "0","%","%d", 1.0, 9);
	//query_min_max("<b>rel. humidity-in</b>",      "humidity",     "indoor",  "0","%","%d" );
	query_min_max("<b>pressure</b>","pressure","indoor","0","hPa","%4.0f", 100);
	query_min_max("<b>wind</b>","speed","wind",1,"km/h","%3.1f",3.6);
	//query_min_max("<b>brightness</b>","lux","brightness",1,"klx","%3.2f",0.001);

	// rain is a special - need to calculate...
	$result=pg_query("SELECT rainfall from rain where datetime = (SELECT max(datetime) from rain );");
	$rain_now = 0.0;
	if ($row=pg_fetch_row($result))
		$rain_now = $row[0]*1000.0;
	$result=pg_query("SELECT rainfall from rain where datetime = (SELECT min(datetime) from rain where datetime > now() AT TIME ZONE 'UTC' - interval '24 hours' );");
	$rain_24 = 0.0;
	if ($row=pg_fetch_row($result))
		$rain_24 = $row[0]*1000.0;
	$result=pg_query("SELECT rainfall from rain where datetime = (SELECT min(datetime) from rain where datetime > now() AT TIME ZONE 'UTC' - interval '48 hours' );");
	$rain_48 = 0.0;
	if ($row=pg_fetch_row($result))
		$rain_48 = $row[0]*1000.0;
	$result=pg_query("SELECT rainfall from rain where datetime = (SELECT min(datetime) from rain where datetime > now() AT TIME ZONE 'UTC' - interval '72 hours' );");
	$rain_72 = 0.0; 
	if ($row=pg_fetch_row($result))
		$rain_72 = $row[0]*1000.0;
	$result=pg_query("SELECT rainfall from rain where datetime = (SELECT min(datetime) from rain where datetime > now() AT TIME ZONE 'UTC' - interval '7 days' );");
	$rain_7days = 0.0; 
	if ($row=pg_fetch_row($result))
		$rain_7days = $row[0]*1000.0;

	print "<tr>\n";   // start new table row
	print "<td bgcolor=\"#99CCFF\"> <b>rain</b> (mm)</td>\n" ;
	print "<td           align=right bgcolor=\"#ffffcc\"></td>\n";
	printf ("%s%3.2f%s", "<td colspan=2 align=right bgcolor=\"#ffffcc\">", ($rain_now - $rain_24) , "</td>\n");
	printf ("%s%3.2f%s", "<td colspan=2 align=right bgcolor=\"#ffffcc\">", ($rain_now - $rain_48) , "</td>\n");
	printf ("%s%3.2f%s", "<td colspan=2 align=right bgcolor=\"#ffffcc\">", ($rain_now - $rain_72) , "</td>\n");
	printf ("%s%3.2f%s", "<td colspan=2 align=right bgcolor=\"#ffffcc\">", ($rain_now - $rain_7days) , "</td>\n");
	print "</tr>\n";

	print "</table><br>\n";
	flush();

	pg_close($dbcon);

}; // function emit_html_table()


function query_min_max($name, $field, $table, $max_only, $units, $format, $mult_constant=1.0, $addr="")
{
	print "<tr>\n";   // start new table row
	print "<td bgcolor=\"#99CCFF\">" . $name . " (" . $units . ")</td>\n" ;

	// Get current values first ...

	if ($table=="wind")
	{
		$query = "SELECT " . $field . ",direction,deviation from " . $table . " where datetime = (SELECT max(datetime) from " . $table ;
		if ($addr != "")
			$query = $query . " WHERE address = '". $addr . "'" ;
		$query = $query . ");" ;
		$result=pg_query($query);
		if (!$result) barf("can't read any wind data from query: " . $query);

		if ($result && ($row=pg_fetch_row($result)))
		{
               		print "<td align=right bgcolor=\"#ffffcc\">" ;
			printf($format . "<br>%d&deg; &plusmn; %d", $row[0]*$mult_constant, $row[1], $row[2] );
			print "</td>\n" ;
		}
		else
		{
			debug("no rows returned from query: " . $query);
               		print "<td align=right bgcolor=\"#ffffcc\">" ;
			printf("<br>N/A" );
			print "</td>\n" ;
		};
	}
	else
	{
		$query = "SELECT " . $field . " from " . $table . " where datetime = (SELECT max(datetime) from " . $table ;
		if ($addr != "")
			$query = $query . " WHERE address = '" . $addr . "'" ;
		$query = $query . ");" ;
		$result=pg_query($query);
		if (!$result) barf("can't read any data from query: " . $query);

		if ($result && ($row=pg_fetch_row($result)))
		{
               		print "<td align=right bgcolor=\"#ffffcc\">" ;
			printf($format, $row[0]*$mult_constant);
			print "</td>\n" ;
		}
		else
		{
			debug("no rows returned from query: " . $query);
               		print "<td align=right bgcolor=\"#ffffcc\">" ;
			printf("N/A");
			print "</td>\n" ;
		};
	};

	$time_interval_array = array("24 hours", "48 hours", "72 hours", "7 days" );
	foreach ($time_interval_array as $time_interval)
	{
		if ($max_only)
		{
			$query = "SELECT max(" . $field . ") from " . $table . " where datetime > now() AT TIME ZONE 'UTC' - interval '" . $time_interval . "'";
			if ($addr != "")
				$query = $query . " AND address = '" . $addr . "'" ;
			$query = $query . " ;" ;
			$result=pg_query($query);
			if (!$result) debug("query failed: " . $query);
		}
		else
		{
			$query = "SELECT min(" . $field . "),max(" . $field . ") from " . $table . " where datetime > now() AT TIME ZONE 'UTC' - interval '" . $time_interval . "'";
			if ($addr != "")
				$query = $query . " AND address = '" . $addr . "'" ;
			$query = $query . " ;" ;
			$result=pg_query($query);
			if (!$result) debug("query failed: " . $query);
		};

		if ($result && ($row=pg_fetch_row($result)))
		{
			if ($max_only)
			{
                		print "<td colspan=2 align=right bgcolor=\"#ffffcc\">" ;
				printf($format, $row[0]*$mult_constant);
				print " </td>\n" ;
			}
			else
			{
                		print "<td align=right bgcolor=\"#ffffcc\">" ;
			        printf($format, $row[0]*$mult_constant);
				print " </td>" ;
				print "<td align=right bgcolor=\"#ffffcc\">" ;
				printf($format, $row[1]*$mult_constant);
				print " </td>\n" ;
			}
		}
		else
		{
			debug("no rows returned from query: " . $query);
			if ($max_only)
			{
                		print "<td colspan=2 align=right bgcolor=\"#ffffcc\">" ;
				printf("N/A");
				print " </td>\n" ;
			}
			else
			{
                		print "<td align=right bgcolor=\"#ffffcc\">" ;
				printf("N/A");
				print " </td>" ;
				print "<td align=right bgcolor=\"#ffffcc\">" ;
				printf("N/A");
				print " </td>\n" ;
			}
		}
	};

	print "</tr>\n\n";
};


function barf($msg)
{
  flush();
  global $argv;
  error_log($argv[0] . ": FATAL: " . $msg);
  exit(1);
};

function debug($msg)
{
  flush();
  global $argv;
  error_log($argv[0] . ": " . $msg);
};

function get_db_connect_string()
{
  return "dbname=weatherdb user=weatherdbuser password=weatherdbpass";
};

function main()
{
  debug("starting");
  print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n";
  print "<html>\n<head>\n";
  print "<title>YourTown Weather</title>\n";
  print "</head>\n<body>\n";
  print "<h1>YourTown Weather</h1>\n";
  print "Updated every 15 minutes.  Last update: " . strftime("%c") . "<br/>\n";
  #print "TODO: make graphs better - see <a href=\"http://www.uni-koblenz.de/~krienke/ftp/unix/ws2500/\">Koblenz University</a> (live demo including wind graph with alpha blending <a href=\"http://userpages.uni-koblenz.de/~krienke/wetter/wetter.cgi\">
 # here</a>).</small>";
  print "<small>For the one-year view, click <a href=\"/weather/longterm\">here</a>.</small>";

  print "<br><br>\n";
  print "<img src=\"rainfall.png\" border=\"1\" alt=\"rainfall\"><br>\n";

  print "<br>\n";
  print "<img src=\"outdoor-dewpoint.png\" border=\"1\" alt=\"dew point\"><br>\n";

  print "<br>\n";
  print "<img src=\"pressure.png\" border=\"1\" alt=\"pressure\"><br>\n";

  print "<br>\n";
  print "<img src=\"windspeed.png\" border=\"1\" alt=\"wind speed\"><br>\n";

  print "<br>\n";
  print "<img src=\"windirection.png\" border=\"1\" alt=\"wind direction\"><br>\n";

  print "<br>\n";
  flush();
  emit_html_table();

  print "<p>\n";
  print "<a href=\"/index.shtml\"><img src=/home.gif alt=\"home\"></a>\n";
  print "<a href=\"/email.shtml\"><img src=/mail.gif alt=\"mail\"></a>\n";
  print "</body>\n";
  print "</html>\n";

  debug("ending cleanly.");
  exit(0);

}; // function main()
